/***************************************************************************
 *
 * QWIX - QWK mail packet reader Version 2.0
 * 
 * Copyright:	Dave MacRae 1992
 *
 * This source code may be freely distributed on the condition that is 
 * distributed in its entirety and that this notice is included. and that
 * no charge is made for this distribution, except for possible media costs.
 *
 ***************************************************************************
 */
static char sccsid[] = "@(#) control.c 2.2 1/22/92 12:49:09";
/*
This file contains the control file specific stuff, eventually it will
be used more than once.
*/

#include "qwix.h"

extern struct control control;
extern struct conf *conf;

static char control_file[80];

read_control() {

    FILE *fp;
    char tmp[CL_LENGTH];
    int i,j;
    struct conf **last; /* used to store pointer the previous pointer */

    sprintf(control_file, "%s/%s", QWK_FILES, CONTROLFILE);

    fp = fopen(control_file, "r");
    for(i = 0;i < SKIP1;i++) /* SKIP */
    	fgets(tmp, CL_LENGTH, fp);

    fgets(tmp, CL_LENGTH,fp); /* read in the board id */
    gtboard(control.board,tmp); /* convert it into a useful form */

    fgets(tmp, CL_LENGTH,fp); /* read in the date and time of packet */
    get_date_time(tmp);

    fgets(control.name, NAMESIZE, fp); /* My name, used to locate personels */
    
    for(i=0;i<SKIP3;i++) 
    	fgets(tmp,CL_LENGTH,fp);

    fgets(tmp,CL_LENGTH,fp); /* Number of confernces on this QWK */
    control.concount=atoi(tmp)+1; /* The main board isn't counted */
    last= &control.conhead;


    for(i=0;i<control.concount;i++){
    	conf=(struct conf *)malloc(sizeof(struct conf));
    	(*last)=conf; /* sort out the forward pointer */
    	last= &(conf->next);
    	fgets(tmp,CL_LENGTH,fp);
    	conf->number=atoi(tmp); 
    	fgets(conf->name,NAMESIZE,fp);
    	stripcr(conf->name);
                mkokstr(conf->name);
    	}

    fclose(fp);
}

gtboard(dest,source)
char *dest;
char *source;
{
    int i,j;
    char x;

    for(i=strlen(source);source[i]!=','&i>0;i--)
    	; /* No-op, work done in for */

    i++;

    for(j=0;!isalpha(source[j]);j++)
    dest[j]=mkok(source[i+j]);
    dest[j--]=0;
}

char *getconf(target)
int target;
/*
 Traces down the conference list looking for a match.

 set the global conf pointer to point to the match or if no match then
 nowhere.
*/
{
    int i;

    conf=control.conhead;

    for(i=0;i<control.concount;i++){
    	if(target==conf->number)
    		return(conf->name);
    	conf=conf->next;
    	}
    return((char *)NULL);
}

get_date_time (szTmp)
char *szTmp;
{

    register i;

    memcpy(control.date, szTmp, 10);
    control.date[10] = NULL;

    memcpy(control.time, szTmp + 11, 8);
    control.time[8] = NULL;

    return 0;
}
